/*
 * File: app/view/ConnectionsContainer.js
 *
 * This file was generated by Sencha Architect version 3.5.1.
 * http://www.sencha.com/products/architect/
 *
 * This file requires use of the Ext JS 4.2.x library, under independent license.
 * License of Sencha Architect does not include license for Ext JS 4.2.x. For more
 * details see http://www.sencha.com/license or contact license@sencha.com.
 *
 * This file will be auto-generated each and everytime you save your project.
 *
 * Do NOT hand edit this file.
 */

Ext.define('qualitor_integration.view.ConnectionsContainer', {
    extend: 'Ext.container.Viewport',

    requires: [
        'Ext.view.View',
        'Ext.XTemplate',
        'Ext.button.Button',
        'Ext.form.Panel',
        'Ext.toolbar.Toolbar',
        'Ext.form.field.ComboBox',
        'Ext.form.FieldSet',
        'Ext.form.field.Checkbox',
        'Ext.form.Label'
    ],

    id: 'ConnectionsContainer',

    layout: {
        type: 'vbox',
        align: 'stretch'
    },

    initComponent: function() {
        var me = this;

        Ext.applyIf(me, {
            items: [
                {
                    xtype: 'container',
                    flex: 1,
                    id: 'connectionsContent',
                    layout: {
                        type: 'hbox',
                        align: 'stretch'
                    },
                    items: [
                        {
                            xtype: 'container',
                            flex: 1,
                            id: 'connectionsCards',
                            layout: 'card',
                            items: [
                                {
                                    xtype: 'container',
                                    id: 'connectionsActiveList',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch',
                                        padding: '0 20 0 0'
                                    },
                                    items: [
                                        {
                                            xtype: 'container',
                                            flex: 1
                                        },
                                        {
                                            xtype: 'container',
                                            flex: 1,
                                            id: 'connectionsActiveAddnew',
                                            maxWidth: 400,
                                            minWidth: 400,
                                            width: 400,
                                            layout: {
                                                type: 'vbox',
                                                align: 'stretch'
                                            },
                                            items: [
                                                {
                                                    xtype: 'panel',
                                                    height: 400,
                                                    margin: '40 0 0',
                                                    maxHeight: 400,
                                                    minHeight: 400,
                                                    width: 300,
                                                    overflowY: 'auto',
                                                    layout: 'anchor',
                                                    title: 'Active Connections',
                                                    items: [
                                                        {
                                                            xtype: 'dataview',
                                                            callTip: function(el, msg) {
                                                                Ext.create('Ext.tip.ToolTip', {
                                                                    target: el,
                                                                    html: msg,
                                                                    showDelay: 0
                                                                });
                                                            },
                                                            removeMsg: function(item, name, logText) {
                                                                Ext.Msg.show({
                                                                    title: 'Remove ' + name,
                                                                    msg: 'Do you really want to remove this connection?',
                                                                    buttons: Ext.Msg.YESNO,
                                                                    buttonText: {
                                                                        yes: 'Yes',
                                                                        no: 'Cancel'
                                                                    },
                                                                    fn: function(btn) {

                                                                        if (btn !== "yes") {
                                                                            return;
                                                                        }

                                                                        Ext.getCmp("connectionsLogScreen").loadingLog(true);
                                                                        Ext.getCmp("connectionsLogScreen").printLog("success", "Removing "+name);

                                                                        Ext.Ajax.request({

                                                                            url: "/opmon/opcfg/qualitor/ws/",
                                                                            params: {
                                                                                action: "crud",
                                                                                operation: "delete",
                                                                                contact_name: name
                                                                            },

                                                                            success: function(response) {

                                                                                var obj;
                                                                                var i;
                                                                                var msg;
                                                                                var msgtype;

                                                                                try {
                                                                                    obj = JSON.parse(response.responseText);
                                                                                    if (obj.response_status.status != 1) {
                                                                                        Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                                                                                        Ext.getCmp("connectionsLogScreen").loadingLog(false);
                                                                                        return;
                                                                                    }

                                                                                    var myapp = qualitor_integration.getApplication();
                                                                                    var connStore = myapp.getQualitorConnectionStore();
                                                                                    connStore.load();

                                                                                    Ext.getCmp("connectionsLogScreen").printLog("success", "Done");

                                                                                } catch(err) {
                                                                                    Ext.getCmp("connectionsLogScreen").printLog("critical", err.message);
                                                                                }

                                                                                Ext.getCmp("connectionsLogScreen").loadingLog(false);

                                                                            },
                                                                            failure: function(response) {
                                                                                Ext.getCmp("connectionsLogScreen").printLog("critical", response);
                                                                                Ext.getCmp("connectionsLogScreen").loadingLog(false);
                                                                            }

                                                                        });
                                                                    },
                                                                    icon: Ext.Msg.QUESTION
                                                                });
                                                            },
                                                            id: 'connectionsActiveListItems',
                                                            itemCls: 'x-dataview-item connection-item',
                                                            itemSelector: 'div',
                                                            itemTpl: [
                                                                '<span class="connection-name">{contact_name}</span>',
                                                                '<a class="connection-tool connection-edit" onmouseover="javascript:Ext.getCmp(\'connectionsActiveListItems\').callTip(this,\'Edit\');" href="#"></a>',
                                                                '<a class="connection-tool connection-test" onmouseover="javascript:Ext.getCmp(\'connectionsActiveListItems\').callTip(this,\'Test\');" href="#"></a>',
                                                                '<a class="connection-tool connection-remove" onmouseover="javascript:Ext.getCmp(\'connectionsActiveListItems\').callTip(this,\'Remove\');" href="#"></a>'
                                                            ],
                                                            store: 'QualitorConnection',
                                                            listeners: {
                                                                itemclick: {
                                                                    fn: me.onDataviewItemClick,
                                                                    scope: me
                                                                }
                                                            }
                                                        }
                                                    ]
                                                },
                                                {
                                                    xtype: 'container',
                                                    flex: 1,
                                                    height: 40,
                                                    id: 'connectionsActiveAddnewWrapper',
                                                    margin: '10 0 0',
                                                    maxHeight: 40,
                                                    layout: {
                                                        type: 'hbox',
                                                        align: 'stretch'
                                                    },
                                                    items: [
                                                        {
                                                            xtype: 'button',
                                                            exampleFunctionreturn: function(test_param) {
                                                                if (test_param === true) {
                                                                    console.log(1);
                                                                    return "adding new connection";
                                                                } else {
                                                                    console.log(0);
                                                                    return "nothing new";
                                                                }
                                                            },
                                                            flex: 1,
                                                            height: 25,
                                                            maxHeight: 27,
                                                            glyph: 43,
                                                            text: 'Add new connection',
                                                            listeners: {
                                                                click: {
                                                                    fn: me.onButtonClick,
                                                                    scope: me
                                                                }
                                                            }
                                                        },
                                                        {
                                                            xtype: 'container',
                                                            flex: 1
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ]
                                },
                                {
                                    xtype: 'container',
                                    id: 'connectionsNewStep01',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch',
                                        padding: '0 20 0 0'
                                    },
                                    items: [
                                        {
                                            xtype: 'container',
                                            flex: 1
                                        },
                                        {
                                            xtype: 'container',
                                            flex: 1,
                                            margin: '40 0 0',
                                            maxWidth: 400,
                                            minWidth: 400,
                                            width: 400,
                                            layout: {
                                                type: 'vbox',
                                                align: 'stretch'
                                            },
                                            items: [
                                                {
                                                    xtype: 'form',
                                                    flex: 1,
                                                    maxHeight: 400,
                                                    bodyPadding: 20,
                                                    title: 'New connection',
                                                    items: [
                                                        {
                                                            xtype: 'textfield',
                                                            anchor: '100%',
                                                            id: 'connectionsNewName',
                                                            fieldLabel: 'Connection name',
                                                            labelAlign: 'top',
                                                            labelSeparator: ' ',
                                                            listeners: {
                                                                blur: {
                                                                    fn: me.onConnectionsNewNameBlur,
                                                                    scope: me
                                                                }
                                                            }
                                                        },
                                                        {
                                                            xtype: 'textfield',
                                                            anchor: '100%',
                                                            id: 'connectionsNewUrl',
                                                            fieldLabel: 'Connection URL',
                                                            labelAlign: 'top',
                                                            labelSeparator: ' '
                                                        }
                                                    ],
                                                    dockedItems: [
                                                        {
                                                            xtype: 'toolbar',
                                                            dock: 'bottom',
                                                            items: [
                                                                {
                                                                    xtype: 'button',
                                                                    text: 'Cancel',
                                                                    listeners: {
                                                                        click: {
                                                                            fn: me.onButtonClick2,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    flex: 1
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    items: [
                                                                        {
                                                                            xtype: 'button',
                                                                            id: 'connectionsNewStep01Advance',
                                                                            text: 'Search URL',
                                                                            listeners: {
                                                                                click: {
                                                                                    fn: me.onButtonClick1,
                                                                                    scope: me
                                                                                }
                                                                            }
                                                                        }
                                                                    ]
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ],
                                    listeners: {
                                        activate: {
                                            fn: me.onConnectionsNewStep01Activate,
                                            scope: me
                                        }
                                    }
                                },
                                {
                                    xtype: 'container',
                                    id: 'connectionsNewStep02',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch',
                                        padding: '0 20 0 0'
                                    },
                                    items: [
                                        {
                                            xtype: 'container',
                                            flex: 1
                                        },
                                        {
                                            xtype: 'container',
                                            flex: 1,
                                            margin: '40 0 0',
                                            maxWidth: 400,
                                            minWidth: 400,
                                            width: 400,
                                            layout: {
                                                type: 'vbox',
                                                align: 'stretch'
                                            },
                                            items: [
                                                {
                                                    xtype: 'form',
                                                    flex: 1,
                                                    maxHeight: 400,
                                                    bodyPadding: 20,
                                                    title: 'New connection',
                                                    items: [
                                                        {
                                                            xtype: 'textfield',
                                                            anchor: '100%',
                                                            id: 'connectionsNewUsername',
                                                            fieldLabel: 'Username',
                                                            labelAlign: 'top',
                                                            labelSeparator: ' '
                                                        },
                                                        {
                                                            xtype: 'textfield',
                                                            anchor: '100%',
                                                            id: 'connectionsNewPassword',
                                                            fieldLabel: 'Password',
                                                            labelAlign: 'top',
                                                            labelSeparator: ' ',
                                                            inputType: 'password'
                                                        },
                                                        {
                                                            xtype: 'combobox',
                                                            anchor: '100%',
                                                            id: 'connectionsNewCompany',
                                                            fieldLabel: 'Company',
                                                            labelAlign: 'top',
                                                            labelSeparator: ' ',
                                                            displayField: 'nmempresa',
                                                            forceSelection: true,
                                                            queryMode: 'local',
                                                            valueField: 'cdempresa'
                                                        }
                                                    ],
                                                    dockedItems: [
                                                        {
                                                            xtype: 'toolbar',
                                                            dock: 'bottom',
                                                            items: [
                                                                {
                                                                    xtype: 'button',
                                                                    text: 'Back',
                                                                    listeners: {
                                                                        click: {
                                                                            fn: me.onButtonClick3,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    width: 15
                                                                },
                                                                {
                                                                    xtype: 'button',
                                                                    text: 'Cancel',
                                                                    listeners: {
                                                                        click: {
                                                                            fn: me.onButtonClick4,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    flex: 1
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    items: [
                                                                        {
                                                                            xtype: 'button',
                                                                            text: 'Validade data',
                                                                            listeners: {
                                                                                click: {
                                                                                    fn: me.onButtonClick5,
                                                                                    scope: me
                                                                                }
                                                                            }
                                                                        }
                                                                    ]
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ],
                                    listeners: {
                                        activate: {
                                            fn: me.onConnectionsNewStep02Activate,
                                            scope: me
                                        }
                                    }
                                },
                                {
                                    xtype: 'container',
                                    id: 'connectionsNewStep03',
                                    layout: {
                                        type: 'hbox',
                                        align: 'stretch',
                                        padding: '0 20 0 0'
                                    },
                                    items: [
                                        {
                                            xtype: 'container',
                                            flex: 1
                                        },
                                        {
                                            xtype: 'container',
                                            flex: 1,
                                            margin: '40 0 0',
                                            maxWidth: 400,
                                            minWidth: 400,
                                            width: 400,
                                            layout: {
                                                type: 'vbox',
                                                align: 'stretch'
                                            },
                                            items: [
                                                {
                                                    xtype: 'form',
                                                    flex: 1,
                                                    maxHeight: 400,
                                                    overflowY: 'auto',
                                                    bodyPadding: 20,
                                                    title: 'New connection',
                                                    items: [
                                                        {
                                                            xtype: 'fieldset',
                                                            title: 'New ticket configuration',
                                                            items: [
                                                                {
                                                                    xtype: 'combobox',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewModel',
                                                                    fieldLabel: 'Ticket default model',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    enableKeyEvents: true,
                                                                    anyMatch: true,
                                                                    displayField: 'nmperfilchamado',
                                                                    forceSelection: true,
                                                                    minChars: 1,
                                                                    queryMode: 'local',
                                                                    store: 'TicketStore',
                                                                    valueField: 'cdperfilchamado'
                                                                },
                                                                {
                                                                    xtype: 'combobox',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewCustomer',
                                                                    fieldLabel: 'Ticket customer',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    anyMatch: true,
                                                                    displayField: 'nmcliente',
                                                                    forceSelection: true,
                                                                    queryMode: 'local',
                                                                    store: 'CustomerStore',
                                                                    valueField: 'cdcliente'
                                                                },
                                                                {
                                                                    xtype: 'combobox',
                                                                    requestContacts: function(component) {
                                                                        var component = Ext.getCmp("connectionsNewContact");
                                                                        console.log(component.getValue());
                                                                        if (component.getValue().length <= 3) {
                                                                            Ext.getCmp("connectionsNewContact").markInvalid("Write at least 3 characters");
                                                                        }

                                                                        validationMask = new Ext.LoadMask(Ext.getBody(), {msg:"Waiting for Qualitor response..."});
                                                                        validationMask.show();
                                                                        Ext.getCmp("connectionsNewContact").triggerBlur();
                                                                        Ext.getCmp("connectionsLogScreen").printLog("success", "Retrieving customer contacts.");


                                                                        qualitor_integration.conn.get_customer_contact(function(obj){

                                                                            if (obj.response_status.status != 1) {
                                                                                Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                                                                                component.markInvalid(obj.response_status.msg);
                                                                                validationMask.destroy();
                                                                                Ext.getCmp("connectionsNewContact").onTriggerClick();
                                                                                return;
                                                                            }

                                                                            if (obj.response_data.dataitem) {
                                                                                console.log(obj.response_data.dataitem);

                                                                                Ext.getStore("ContactStore").removeAll();
                                                                                Ext.getStore("ContactStore").add(obj.response_data.dataitem);
                                                                                Ext.getCmp("connectionsLogScreen").printLog("success", "Customer contact(s) retrieved.");
                                                                                Ext.getCmp("connectionsNewStep03Advance").setDisabled(false);
                                                                                component.onTriggerClick();
                                                                                component.forceSelection = true;

                                                                            } else {
                                                                                //console.log(false);
                                                                                component.markInvalid("Contact is invalid");
                                                                                Ext.getCmp("connectionsNewStep03Advance").setDisabled(true);
                                                                                Ext.getCmp("connectionsLogScreen").printLog("critical", "Customer contact cannot be retrieved.");
                                                                                component.forceSelection = false;
                                                                            }


                                                                            validationMask.destroy();

                                                                        });

                                                                    },
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewContact',
                                                                    fieldLabel: 'Ticket contact',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    allowBlank: false,
                                                                    emptyText: 'Start writing to search for contact names',
                                                                    enableKeyEvents: true,
                                                                    displayField: 'nmcontato',
                                                                    queryMode: 'local',
                                                                    store: 'ContactStore',
                                                                    listeners: {
                                                                        keyup: {
                                                                            fn: me.onConnectionsNewContactKeyup,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'combobox',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewTeam',
                                                                    fieldLabel: 'Responsible team',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    anyMatch: true,
                                                                    displayField: 'nmequipe',
                                                                    forceSelection: true,
                                                                    queryMode: 'local',
                                                                    store: 'TeamsStore',
                                                                    valueField: 'cdequipe'
                                                                },
                                                                {
                                                                    xtype: 'checkboxfield',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewRecovery',
                                                                    fieldLabel: 'Label',
                                                                    hideLabel: true,
                                                                    boxLabel: 'Close ticket on recovery'
                                                                }
                                                            ]
                                                        },
                                                        {
                                                            xtype: 'fieldset',
                                                            title: 'State correlation',
                                                            items: [
                                                                {
                                                                    xtype: 'container',
                                                                    margin: '10 0 15',
                                                                    layout: {
                                                                        type: 'hbox',
                                                                        align: 'stretch'
                                                                    },
                                                                    items: [
                                                                        {
                                                                            xtype: 'container',
                                                                            flex: 1,
                                                                            maxWidth: 106,
                                                                            items: [
                                                                                {
                                                                                    xtype: 'label',
                                                                                    renderTpl: [
                                                                                        '<i>{%this.renderContent(out,values)%}</i>'
                                                                                    ],
                                                                                    text: 'OpMon states'
                                                                                }
                                                                            ]
                                                                        },
                                                                        {
                                                                            xtype: 'container',
                                                                            flex: 1,
                                                                            items: [
                                                                                {
                                                                                    xtype: 'label',
                                                                                    renderTpl: [
                                                                                        '<i>{%this.renderContent(out,values)%}</i>'
                                                                                    ],
                                                                                    text: 'Qualitor states'
                                                                                }
                                                                            ]
                                                                        }
                                                                    ]
                                                                },
                                                                {
                                                                    xtype: 'combobox',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewStateOk',
                                                                    fieldLabel: 'OK/UP',
                                                                    labelSeparator: ' ',
                                                                    displayField: 'nmseveridade',
                                                                    forceSelection: true,
                                                                    queryMode: 'local',
                                                                    store: 'SevStore',
                                                                    valueField: 'cdseveridade'
                                                                },
                                                                {
                                                                    xtype: 'combobox',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewStateWarning',
                                                                    fieldLabel: 'Warning',
                                                                    labelSeparator: ' ',
                                                                    displayField: 'nmseveridade',
                                                                    forceSelection: true,
                                                                    queryMode: 'local',
                                                                    store: 'SevStore',
                                                                    valueField: 'cdseveridade'
                                                                },
                                                                {
                                                                    xtype: 'combobox',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewStateCritical',
                                                                    fieldLabel: 'Critical/Down',
                                                                    labelSeparator: ' ',
                                                                    displayField: 'nmseveridade',
                                                                    forceSelection: true,
                                                                    queryMode: 'local',
                                                                    store: 'SevStore',
                                                                    valueField: 'cdseveridade'
                                                                },
                                                                {
                                                                    xtype: 'combobox',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewStateUnknown',
                                                                    fieldLabel: 'Unknown/Unreachable',
                                                                    labelSeparator: ' ',
                                                                    displayField: 'nmseveridade',
                                                                    forceSelection: true,
                                                                    queryMode: 'local',
                                                                    store: 'SevStore',
                                                                    valueField: 'cdseveridade'
                                                                }
                                                            ]
                                                        },
                                                        {
                                                            xtype: 'fieldset',
                                                            title: 'OpMon\'s IC feedback',
                                                            items: [
                                                                {
                                                                    xtype: 'container',
                                                                    margin: '10 0 15',
                                                                    layout: {
                                                                        type: 'hbox',
                                                                        align: 'stretch'
                                                                    },
                                                                    items: [
                                                                        {
                                                                            xtype: 'label',
                                                                            flex: 1,
                                                                            renderTpl: [
                                                                                '<i>{%this.renderContent(out,values)%}</i>'
                                                                            ],
                                                                            text: 'When qualitors ticket are opened'
                                                                        }
                                                                    ]
                                                                },
                                                                {
                                                                    xtype: 'combobox',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewFeedback',
                                                                    fieldLabel: 'IC receive',
                                                                    labelSeparator: ' ',
                                                                    value: '0',
                                                                    forceSelection: true,
                                                                    queryMode: 'local',
                                                                    store: [
                                                                        [
                                                                            '0',
                                                                            'Acknowledge'
                                                                        ],
                                                                        [
                                                                            '1',
                                                                            'Comment'
                                                                        ]
                                                                    ]
                                                                }
                                                            ]
                                                        },
                                                        {
                                                            xtype: 'fieldset',
                                                            title: 'Server IC configuration',
                                                            items: [
                                                                {
                                                                    xtype: 'combobox',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewLocation',
                                                                    fieldLabel: 'Location',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    displayField: 'nmlocalidade',
                                                                    forceSelection: true,
                                                                    queryMode: 'local',
                                                                    store: 'LocStore',
                                                                    valueField: 'cdlocalidade'
                                                                },
                                                                {
                                                                    xtype: 'combobox',
                                                                    anchor: '100%',
                                                                    id: 'connectionsNewType',
                                                                    fieldLabel: 'Type',
                                                                    labelAlign: 'top',
                                                                    labelSeparator: ' ',
                                                                    displayField: 'nmcategoria',
                                                                    forceSelection: true,
                                                                    queryMode: 'local',
                                                                    store: 'TypeStore',
                                                                    valueField: 'cdcategoria'
                                                                }
                                                            ]
                                                        }
                                                    ],
                                                    dockedItems: [
                                                        {
                                                            xtype: 'toolbar',
                                                            dock: 'bottom',
                                                            items: [
                                                                {
                                                                    xtype: 'button',
                                                                    text: 'Back',
                                                                    listeners: {
                                                                        click: {
                                                                            fn: me.onButtonClick6,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    width: 15
                                                                },
                                                                {
                                                                    xtype: 'button',
                                                                    text: 'Cancel',
                                                                    listeners: {
                                                                        click: {
                                                                            fn: me.onButtonClick7,
                                                                            scope: me
                                                                        }
                                                                    }
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    flex: 1
                                                                },
                                                                {
                                                                    xtype: 'container',
                                                                    items: [
                                                                        {
                                                                            xtype: 'button',
                                                                            disabled: true,
                                                                            id: 'connectionsNewStep03Advance',
                                                                            text: 'Save connection',
                                                                            listeners: {
                                                                                click: {
                                                                                    fn: me.onButtonClick8,
                                                                                    scope: me
                                                                                }
                                                                            }
                                                                        }
                                                                    ]
                                                                }
                                                            ]
                                                        }
                                                    ]
                                                }
                                            ]
                                        }
                                    ],
                                    listeners: {
                                        activate: {
                                            fn: me.onConnectionsNewStep03Activate,
                                            scope: me
                                        }
                                    }
                                }
                            ]
                        },
                        {
                            xtype: 'container',
                            flex: 1,
                            width: 300,
                            layout: {
                                type: 'vbox',
                                padding: '0 0 0 20'
                            },
                            items: [
                                {
                                    xtype: 'panel',
                                    printLog: function(state, msg) {
                                        var logScreen, logScroll;

                                        logScreen = this;
                                        logScreen.add( {xtype: "container", cls: state+"-text black-bg", html: msg} );
                                        logScroll = logScreen.body;
                                        logScroll.dom.scrollTop = logScroll.dom.scrollHeight - window.parseInt(logScroll.dom.style.height);

                                        //console.log(el.xtype);
                                    },
                                    loadingLog: function(areLoading) {
                                        if (areLoading) {
                                            Ext.getCmp("connectionsLogScreen").setIcon("/opmon/opcfg/images/load.gif");
                                        } else {
                                            Ext.getCmp("connectionsLogScreen").setIcon(Ext.BLANK_IMAGE_URL);
                                        }

                                        return;


                                        var logScreen, logScroll, counter, text, loadInterval;

                                        logScreen = this;
                                        counter = 0;
                                        text = "loading";
                                        loadInterval = 0;


                                        if (areLoading === true) {
                                            logScreen.add({xtype: "container", id: "loading_container", cls:"white-text black-bg", html: "<div id='loading_box'></div>"} );
                                            loadInterval = setInterval(function() {
                                                document.getElementById("loading_box").innerHTML = text+Array((++counter % 4)+1).join(".");
                                            }, 200);
                                        } else {
                                            logScreen.remove(Ext.getCmp("loading_container"));
                                            clearInterval(loadInterval);
                                        }

                                        logScroll = logScreen.body;
                                        logScroll.dom.scrollTop = logScroll.dom.scrollHeight - window.parseInt(logScroll.dom.style.height);
                                    },
                                    cls: 'black-bg',
                                    height: 400,
                                    id: 'connectionsLogScreen',
                                    margin: '40 0 0',
                                    maxHeight: 400,
                                    minHeight: 400,
                                    width: 300,
                                    autoScroll: true,
                                    bodyCls: [
                                        'black-bg',
                                        'console-log'
                                    ],
                                    bodyPadding: 15,
                                    icon: '',
                                    title: 'Logs',
                                    items: [
                                        {
                                            xtype: 'container',
                                            cls: 'white-text black-bg',
                                            html: 'OpMon + Qualitor Integration 1.0',
                                            id: 'startLog'
                                        }
                                    ]
                                }
                            ]
                        }
                    ]
                }
            ]
        });

        me.callParent(arguments);
    },

    onDataviewItemClick: function(dataview, record, item, index, e, eOpts) {
        var clickedTool;
        var clickedItem;
        var clickedAuth;
        var clickedAction;
        var myapp;
        var connStore;
        var conn;


        myapp = qualitor_integration.getApplication();
        connStore = myapp.getQualitorConnectionStore();

        clickedTool = e.target.className;
        clickedTool = clickedTool.split(' ');
        clickedAuth = clickedTool[0];
        clickedAction = clickedTool[1];

        clickedItem = item.childNodes.item('span').innerHTML;

        if (clickedAuth != 'connection-tool') {
            return false;
        }

        switch (clickedAction) {

            case 'connection-remove':
                clickedAction = 'Removing';
                Ext.getCmp('connectionsActiveListItems').removeMsg(item, clickedItem, clickedAction + ' ' + clickedItem);
                return;

            case 'connection-test':
                conn = connStore.find("contact_name",clickedItem);
                if (conn < 0) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", "Invalid connection");
                    return;
                }

                conn = connStore.getAt(conn);
                Ext.getCmp("connectionsLogScreen").loadingLog(true);
                conn.test();
                return;

            case 'connection-edit':

                conn = connStore.find("contact_name",clickedItem);
                if (conn < 0) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", "Invalid connection");
                    return;
                }

                var cardsContainer;
                qualitor_integration.conn =  connStore.getAt(conn);
                qualitor_integration.editing_new = false;

                cardsContainer = Ext.getCmp("connectionsCards");
                cardsContainer.getLayout().setActiveItem(1);
                return;

        }

    },

    onButtonClick: function(button, e, eOpts) {
        var cardsContainer;

        cardsContainer = button.up("#connectionsCards");
        cardsContainer.getLayout().setActiveItem(1);
    },

    onConnectionsNewNameBlur: function(component, e, eOpts) {
        component.setValue(changeCharCode(component.getValue()));
    },

    onButtonClick2: function(button, e, eOpts) {
        var cardsContainer;

        delete qualitor_integration.conn;
        cardsContainer = button.up("#connectionsCards");
        cardsContainer.getLayout().setActiveItem(0);
    },

    onButtonClick1: function(button, e, eOpts) {
        var cardsContainer;
        var fieldName;
        var fieldUrl;


        var myapp = qualitor_integration.getApplication();
        var connStore = myapp.getQualitorConnectionStore();

        var idx = connStore.find("contact_name",Ext.getCmp("connectionsNewName").value);
        if (qualitor_integration.editing_new === true && idx >= 0) {
            Ext.Msg.show({
                title: 'Invalid connection name',
                msg: 'A connection with this name already exists',
                buttons: Ext.Msg.YES,
                buttonText: {
                    yes: 'OK'
                }
            });
            return;
        }

        cardsContainer = button.up("#connectionsCards");

        qualitor_integration.conn.set("contact_name",Ext.getCmp("connectionsNewName").value);
        qualitor_integration.conn.set("url",Ext.getCmp("connectionsNewUrl").value);

        Ext.getCmp("connectionsLogScreen").loadingLog(true);
        Ext.getCmp("connectionsLogScreen").printLog("success", "Validating url");
        qualitor_integration.conn.validate_url(function(obj) {

            /* validating callback */
            if (obj.response_status.status != 1) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                Ext.getCmp("connectionsLogScreen").loadingLog(false);
                return;
            }
            Ext.getCmp("connectionsLogScreen").printLog("success", "Done.");


            /* get companies */
            Ext.getCmp("connectionsLogScreen").printLog("success", "Retrieving companies.");
            qualitor_integration.conn.get_company(function(obj) {

                if (obj.response_status.status != 1) {
                    Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                    Ext.getCmp("connectionsLogScreen").loadingLog(false);
                    return;
                }

                Ext.getCmp("connectionsLogScreen").printLog("success", "Done.");

                var company_store = Ext.create('Ext.data.Store', {
                    fields: ["cdempresa", "nmempresa"],
                    data: obj.response_data.dataitem
                });


                Ext.getCmp("connectionsNewCompany").store = company_store;

                //qualitor_integration.company = obj.response_data.dataitem;
                cardsContainer.getLayout().setActiveItem(2);
                Ext.getCmp("connectionsLogScreen").loadingLog(false);

            });

        });
    },

    onConnectionsNewStep01Activate: function(component, eOpts) {
        /* new connection */
        if (qualitor_integration.conn === undefined) {
            qualitor_integration.conn = Ext.create('qualitor_integration.model.QualitorConnectionModel',{});
            qualitor_integration.editing_new = true;
        }

        Ext.getCmp("connectionsNewName").setValue(
            qualitor_integration.conn.get("contact_name")
        );

        Ext.getCmp("connectionsNewUrl").setValue(
            qualitor_integration.conn.get("url")
        );

        if (qualitor_integration.editing_new === true) {
            Ext.getCmp("connectionsNewName").enable();
        } else {
            Ext.getCmp("connectionsNewName").disable();
        }
    },

    onButtonClick3: function(button, e, eOpts) {
        var cardsContainer;

        cardsContainer = button.up("#connectionsCards");
        cardsContainer.getLayout().setActiveItem(1);
    },

    onButtonClick4: function(button, e, eOpts) {
        var cardsContainer;

        delete qualitor_integration.conn;
        cardsContainer = button.up("#connectionsCards");
        cardsContainer.getLayout().setActiveItem(0);
    },

    onButtonClick5: function(button, e, eOpts) {
        var cardsContainer, fieldUsername, fieldPassword, fieldCompany;

        qualitor_integration.conn.set("user",Ext.getCmp("connectionsNewUsername").value);
        qualitor_integration.conn.set("password",Ext.getCmp("connectionsNewPassword").value);
        qualitor_integration.conn.set("company_id",Ext.getCmp("connectionsNewCompany").value);


        var error = 0;
        var pendings = 0;

        Ext.getCmp("connectionsLogScreen").loadingLog(true);

        Ext.getCmp("connectionsLogScreen").printLog("success", "Retrieving ticket models.");
        pendings++;
        qualitor_integration.conn.get_ticket_template(function(obj){

            if (obj.response_status.status != 1) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                pendings--;
                error++;
                return;
            }

            var ticket_models = Ext.getStore("TicketStore");
            ticket_models.removeAll();
            ticket_models.add(obj.response_data.dataitem);

            Ext.getCmp("connectionsLogScreen").printLog("success", "Ticket models retrieved.");

            pendings--;

        });

        Ext.getCmp("connectionsLogScreen").printLog("success", "Retrieving customers.");
        pendings++;
        qualitor_integration.conn.get_customer(function(obj){

            if (obj.response_status.status != 1) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                pendings--;
                error++;
                return;
            }

            var customer = Ext.getStore("CustomerStore");
            customer.removeAll();
            customer.add(obj.response_data.dataitem);


            Ext.getCmp("connectionsLogScreen").printLog("success", "Customers retrieved.");
            pendings--;

        });


        Ext.getCmp("connectionsLogScreen").printLog("success", "Retrieving teams.");
        pendings++;
        qualitor_integration.conn.get_teams(function(obj){

            if (obj.response_status.status != 1) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                pendings--;
                error++;
                return;
            }

            var teams = Ext.getStore("TeamsStore");
            teams.removeAll();
            teams.add(obj.response_data.dataitem);


            Ext.getCmp("connectionsLogScreen").printLog("success", "Teams retrieved.");
            pendings--;

        });


        Ext.getCmp("connectionsLogScreen").printLog("success", "Retrieving severities.");
        pendings++;
        qualitor_integration.conn.get_severities(function(obj){

            if (obj.response_status.status != 1) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                pendings--;
                error++;
                return;
            }

            var sev = Ext.getStore("SevStore");
            sev.removeAll();
            sev.add(obj.response_data.dataitem);


            Ext.getCmp("connectionsLogScreen").printLog("success", "Severities retrieved.");
            pendings--;

        });



        Ext.getCmp("connectionsLogScreen").printLog("success", "Retrieving locations.");
        pendings++;
        qualitor_integration.conn.get_ic_locations(function(obj){

            if (obj.response_status.status != 1) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                pendings--;
                error++;
                return;
            }


            var loc = Ext.getStore("LocStore");
            loc.removeAll();
            loc.add(obj.response_data.dataitem);


            Ext.getCmp("connectionsLogScreen").printLog("success", "Locations retrieved.");
            pendings--;

        });


        Ext.getCmp("connectionsLogScreen").printLog("success", "Retrieving IC types.");
        pendings++;
        qualitor_integration.conn.get_ic_types(function(obj){

            if (obj.response_status.status != 1) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                pendings--;
                error++;
                return;
            }


            var t = Ext.getStore("TypeStore");
            t.removeAll();
            t.add(obj.response_data.dataitem);


            Ext.getCmp("connectionsLogScreen").printLog("success", "IC types retrieved.");
            pendings--;

        });


        end_func = function() {

            if (pendings > 0) {
                setTimeout(end_func, 200);
                return;
            }

            if (error > 0)
                return;

            cardsContainer = button.up("#connectionsCards");
            cardsContainer.getLayout().setActiveItem(3);
            Ext.getCmp("connectionsLogScreen").loadingLog(false);

            Ext.getCmp("connectionsNewModel").setValue(Ext.getStore("TicketStore").getAt('0').get('cdperfilchamado'));
            Ext.getCmp("connectionsNewCustomer").setValue(Ext.getStore("CustomerStore").getAt('0').get('cdcliente'));
            Ext.getCmp("connectionsNewTeam").setValue(Ext.getStore("TeamsStore").getAt('0').get('cdequipe'));
            Ext.getCmp("connectionsNewStateOk").setValue(Ext.getStore("SevStore").getAt('0').get('cdseveridade'));
            Ext.getCmp("connectionsNewStateWarning").setValue(Ext.getStore("SevStore").getAt('1').get('cdseveridade'));
            Ext.getCmp("connectionsNewStateCritical").setValue(Ext.getStore("SevStore").getAt('2').get('cdseveridade'));
            Ext.getCmp("connectionsNewStateUnknown").setValue(Ext.getStore("SevStore").getAt('3').get('cdseveridade'));
            Ext.getCmp("connectionsNewLocation").setValue(Ext.getStore("LocStore").getAt('0').get('cdlocalidade'));
            Ext.getCmp("connectionsNewType").setValue(Ext.getStore("TypeStore").getAt('0').get('cdcategoria'));

        };

        setTimeout(end_func, 200);
    },

    onConnectionsNewStep02Activate: function(component, eOpts) {
        Ext.getCmp("connectionsNewUsername").setValue(
            qualitor_integration.conn.get("user")
        );

        Ext.getCmp("connectionsNewPassword").setValue(
            qualitor_integration.conn.get("password")
        );

        Ext.getCmp("connectionsNewCompany").setValue(
            qualitor_integration.conn.get("company_id")
        );

    },

    onConnectionsNewContactKeyup: function(textfield, e, eOpts) {
        if (window.timer) {
            clearTimeout(window.timer);
        }
        window.timer = setTimeout(textfield.requestContacts, 2000);
    },

    onButtonClick6: function(button, e, eOpts) {
        var cardsContainer;

        cardsContainer = button.up("#connectionsCards");
        cardsContainer.getLayout().setActiveItem(2);
    },

    onButtonClick7: function(button, e, eOpts) {
        var cardsContainer;

        delete qualitor_integration.conn;
        cardsContainer = button.up("#connectionsCards");
        cardsContainer.getLayout().setActiveItem(0);
    },

    onButtonClick8: function(button, e, eOpts) {
        var validateFields = [
            "connectionsNewModel",
            "connectionsNewCustomer",
            "connectionsNewContact",
            "connectionsNewTeam",
            "connectionsNewStateOk",
            "connectionsNewStateWarning",
            "connectionsNewStateCritical",
            "connectionsNewStateUnknown",
            "connectionsNewLocation",
            "connectionsNewType",
            "connectionsNewRecovery",
            "connectionsNewFeedback"
        ];


        for(var i in validateFields) {
            var name = validateFields[i];
            var f;

            f = Ext.getCmp(name);
            if (f.getValue() === null) {
                f.markInvalid("This field is mandatory");
                return;
            }
        }


        qualitor_integration.conn.set("ticket_template",Ext.getCmp("connectionsNewModel").value);
        qualitor_integration.conn.set("customer",Ext.getCmp("connectionsNewCustomer").value);
        qualitor_integration.conn.set("customer_contact",Ext.getCmp("connectionsNewContact").value);
        qualitor_integration.conn.set("team",Ext.getCmp("connectionsNewTeam").value);
        qualitor_integration.conn.set("severity_ok",Ext.getCmp("connectionsNewStateOk").value);
        qualitor_integration.conn.set("severity_warning",Ext.getCmp("connectionsNewStateWarning").value);
        qualitor_integration.conn.set("severity_critical",Ext.getCmp("connectionsNewStateCritical").value);
        qualitor_integration.conn.set("severity_unknown",Ext.getCmp("connectionsNewStateUnknown").value);
        qualitor_integration.conn.set("ic_location",Ext.getCmp("connectionsNewLocation").value);
        qualitor_integration.conn.set("ic_type",Ext.getCmp("connectionsNewType").value);
        qualitor_integration.conn.set("close_on_recovery",Ext.getCmp("connectionsNewRecovery").getValue() ? 1 : 0);
        qualitor_integration.conn.set("feedback",Ext.getCmp("connectionsNewFeedback").value);


        Ext.getCmp("connectionsLogScreen").printLog("success", "Saving connection.");

        var new_conn = false;
        if (qualitor_integration.editing_new !== undefined && qualitor_integration.editing_new === true) {
            new_conn = true;
        }

        Ext.getCmp("connectionsLogScreen").loadingLog(true);
        qualitor_integration.conn.save(new_conn, function(obj) {

            if (obj.response_status.status != 1) {
                Ext.getCmp("connectionsLogScreen").printLog("critical", obj.response_status.msg);
                pendings--;
                error++;
                return;
            }

            cardsContainer = button.up("#connectionsCards");
            cardsContainer.getLayout().setActiveItem(0);

            delete qualitor_integration.conn;

            var myapp = qualitor_integration.getApplication();
            var connStore = myapp.getQualitorConnectionStore();
            connStore.load();

            Ext.getCmp("connectionsLogScreen").printLog("success", "Connect saved.");
            Ext.getCmp("connectionsLogScreen").loadingLog(false);
        });
    },

    onConnectionsNewStep03Activate: function(component, eOpts) {
        Ext.getCmp("connectionsNewModel").setValue(
            qualitor_integration.conn.get("ticket_template")
        );

        Ext.getCmp("connectionsNewCustomer").setValue(
            qualitor_integration.conn.get("customer")
        );

        Ext.getCmp("connectionsNewContact").setValue(
            qualitor_integration.conn.get("customer_contact")
        );

        Ext.getCmp("connectionsNewTeam").setValue(
            qualitor_integration.conn.get("team")
        );

        Ext.getCmp("connectionsNewRecovery").setValue(
            qualitor_integration.conn.get("close_on_recovery")
        );

        Ext.getCmp("connectionsNewStateOk").setValue(
            qualitor_integration.conn.get("severity_ok")
        );

        Ext.getCmp("connectionsNewStateWarning").setValue(
            qualitor_integration.conn.get("severity_warning")
        );

        Ext.getCmp("connectionsNewStateCritical").setValue(
            qualitor_integration.conn.get("severity_critical")
        );

        Ext.getCmp("connectionsNewStateUnknown").setValue(
            qualitor_integration.conn.get("severity_unknown")
        );

        Ext.getCmp("connectionsNewLocation").setValue(
            qualitor_integration.conn.get("ic_location")
        );

        Ext.getCmp("connectionsNewType").setValue(
            qualitor_integration.conn.get("ic_type")
        );

        Ext.getCmp("connectionsNewFeedback").setValue(
            qualitor_integration.conn.get("feedback")
        );

    }

});